/**
 * Copyright (c) 2004 - 2011 Eike Stepper (Berlin, Germany) and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *    Eike Stepper - initial API and implementation
 */
package org.eclipse.emf.cdo.tests.util;

import org.eclipse.emf.cdo.common.CDOCommonSession.Options.PassiveUpdateMode;
import org.eclipse.emf.cdo.common.protocol.CDOAuthenticator;
import org.eclipse.emf.cdo.session.CDOSession;
import org.eclipse.emf.cdo.session.CDOSessionConfiguration;

import org.eclipse.net4j.util.event.Notifier;

/**
 * @author Eike Stepper
 */
public abstract class TestSessionConfiguration extends Notifier implements CDOSessionConfiguration
{
  public void setPassiveUpdateMode(PassiveUpdateMode passiveUpdateMode)
  {
    throw new UnsupportedOperationException();
  }

  public void setPassiveUpdateEnabled(boolean passiveUpdateEnabled)
  {
    throw new UnsupportedOperationException();
  }

  public void setExceptionHandler(CDOSession.ExceptionHandler exceptionHandler)
  {
    throw new UnsupportedOperationException();
  }

  public void setActivateOnOpen(boolean activateOnOpen)
  {
    throw new UnsupportedOperationException();
  }

  public boolean isSessionOpen()
  {
    throw new UnsupportedOperationException();
  }

  public boolean isPassiveUpdateEnabled()
  {
    throw new UnsupportedOperationException();
  }

  public boolean isActivateOnOpen()
  {
    throw new UnsupportedOperationException();
  }

  public PassiveUpdateMode getPassiveUpdateMode()
  {
    throw new UnsupportedOperationException();
  }

  public CDOSession.ExceptionHandler getExceptionHandler()
  {
    throw new UnsupportedOperationException();
  }

  public CDOAuthenticator getAuthenticator()
  {
    throw new UnsupportedOperationException();
  }
}
